<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>TourGuideService.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">TourGuide</a> &gt; <a href="index.source.html" class="el_package">tourGuide.service</a> &gt; <span class="el_source">TourGuideService.java</span></div><h1>TourGuideService.java</h1><pre class="source lang-java linenums">package tourGuide.service;

import java.time.LocalDateTime;
import java.time.ZoneOffset;
import java.util.*;
import java.util.concurrent.CompletableFuture;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import gpsUtil.location.Attraction;
import gpsUtil.location.Location;
import gpsUtil.location.VisitedLocation;
import tourGuide.helper.InternalTestHelper;
import tourGuide.tracker.Tracker;
import tourGuide.user.User;
import tourGuide.user.UserReward;
import tripPricer.Provider;
import tripPricer.TripPricer;

@Service
public class TourGuideService {
<span class="fc" id="L25">	private Logger logger = LoggerFactory.getLogger(TourGuideService.class);</span>
	private final GpsUtilService gpsUtilService;
	private final RewardsService rewardsService;
<span class="fc" id="L28">	private final TripPricer tripPricer = new TripPricer();</span>
	public final Tracker tracker;
<span class="fc" id="L30">	boolean testMode = true;</span>

<span class="fc" id="L32">	public TourGuideService(GpsUtilService gpsUtilService, RewardsService rewardsService) {</span>
<span class="fc" id="L33">		this.gpsUtilService = gpsUtilService;</span>
<span class="fc" id="L34">		this.rewardsService = rewardsService;</span>

<span class="pc bpc" id="L36" title="1 of 2 branches missed.">		if(testMode) {</span>
<span class="fc" id="L37">			logger.info(&quot;TestMode enabled&quot;);</span>
<span class="fc" id="L38">			logger.debug(&quot;Initializing users&quot;);</span>
<span class="fc" id="L39">			initializeInternalUsers();</span>
<span class="fc" id="L40">			logger.debug(&quot;Finished initializing users&quot;);</span>
		}
<span class="fc" id="L42">		tracker = new Tracker(this);</span>
<span class="fc" id="L43">		addShutDownHook();</span>
<span class="fc" id="L44">	}</span>

	public List&lt;UserReward&gt; getUserRewards(User user) {
<span class="fc" id="L47">		return user.getUserRewards();</span>
	}

	public VisitedLocation getUserLocation(User user) {
<span class="fc" id="L51">		return user.getLastVisitedLocation();</span>
	}

	public User getUser(String userName) {
<span class="fc" id="L55">		return internalUserMap.get(userName);</span>
	}

	public List&lt;User&gt; getAllUsers() {
<span class="fc" id="L59">		return internalUserMap.values().stream().parallel().collect(Collectors.toList());</span>
	}

	public void addUser(User user) {
<span class="pc bpc" id="L63" title="1 of 2 branches missed.">		if(!internalUserMap.containsKey(user.getUserName())) {</span>
<span class="fc" id="L64">			internalUserMap.put(user.getUserName(), user);</span>
		}
<span class="fc" id="L66">	}</span>

	public void trackUserLocation(User user) {
<span class="fc" id="L69">		gpsUtilService.addUserLocation(user, rewardsService);</span>
<span class="fc" id="L70">	}</span>


	public List&lt;Provider&gt; getTripDeals(User user) {
<span class="fc" id="L74">		logger.debug(&quot;User preferences = &quot; + user.getUserPreferences().getNumberOfAdults() + &quot;=numberOfAdults &quot; + user.getUserPreferences().getNumberOfChildren()+&quot;=numberOfChildren&quot;);</span>
<span class="pc" id="L75">		int cumulativeRewardPoints = user.getUserRewards().stream().mapToInt(i -&gt; i.getRewardPoints()).sum();</span>
<span class="fc" id="L76">		List&lt;Provider&gt; providers = tripPricer.getPrice(tripPricerApiKey, user.getUserId(), user.getUserPreferences().getNumberOfAdults(),</span>
<span class="fc" id="L77">				user.getUserPreferences().getNumberOfChildren(), user.getUserPreferences().getTripDuration(), cumulativeRewardPoints);</span>
<span class="fc" id="L78">		user.setTripDeals(providers);</span>

<span class="fc" id="L80">		return providers;</span>
	}

	public List&lt;Map&lt;String, Object&gt;&gt; getNearByAttractions(VisitedLocation visitedLocation, User user) {
<span class="fc" id="L84">		List&lt;Attraction&gt; attractionsList = gpsUtilService.getAttractions();</span>

<span class="fc" id="L86">		List&lt;Map&lt;String, Object&gt;&gt; nearbyAttractions = new ArrayList&lt;&gt;();</span>

<span class="fc bfc" id="L88" title="All 2 branches covered.">		for(Attraction attraction : rewardsService.getSortedAttractions(attractionsList, visitedLocation)) {</span>

<span class="fc" id="L90">			Map&lt;String, Object&gt; touristAttraction = new LinkedHashMap&lt;&gt;();</span>
<span class="fc" id="L91">			touristAttraction.put(&quot;Attraction&quot;, attraction.attractionName);</span>
<span class="fc" id="L92">			touristAttraction.put(&quot;Attraction latitude&quot;, attraction.latitude);</span>
<span class="fc" id="L93">			touristAttraction.put(&quot;Attraction longitude&quot;, attraction.longitude);</span>
<span class="fc" id="L94">			touristAttraction.put(&quot;User's location latitude&quot;, visitedLocation.location.latitude);</span>
<span class="fc" id="L95">			touristAttraction.put(&quot;User's location longitude&quot;, visitedLocation.location.longitude);</span>
<span class="fc" id="L96">			touristAttraction.put(&quot;Distance&quot;, rewardsService.getDistance(attraction, visitedLocation.location));</span>
<span class="fc" id="L97">			touristAttraction.put(&quot;Reward Points&quot;, rewardsService.getAttractionRewardPoint(attraction, user));</span>

<span class="fc" id="L99">			nearbyAttractions.add(touristAttraction);</span>
<span class="fc" id="L100">		}</span>

<span class="fc" id="L102">		return nearbyAttractions;</span>
	}

	public Map&lt;String, Location&gt; getAllUsersLocations() {
<span class="nc" id="L106">		List&lt;User&gt; allUsers = getAllUsers();</span>

<span class="nc" id="L108">		Map&lt;String, Location&gt; location = new LinkedHashMap&lt;&gt;();</span>
<span class="nc" id="L109">		allUsers.forEach(u -&gt; {</span>

<span class="nc" id="L111">			location.put(u.getUserId().toString(), u.getLastVisitedLocation().location);</span>
<span class="nc" id="L112">		});</span>

<span class="nc" id="L114">		return location;</span>
	}

	private void addShutDownHook() {
<span class="fc" id="L118">		Runtime.getRuntime().addShutdownHook(new Thread() {</span>
			public void run() {
<span class="fc" id="L120">				tracker.stopTracking();</span>
<span class="fc" id="L121">			}</span>
		});
<span class="fc" id="L123">	}</span>

	/**********************************************************************************
	 *
	 * Methods Below: For Internal Testing
	 *
	 **********************************************************************************/
	private static final String tripPricerApiKey = &quot;test-server-api-key&quot;;
	// Database connection will be used for external users, but for testing purposes internal users are provided and stored in memory
<span class="fc" id="L132">	private final Map&lt;String, User&gt; internalUserMap = new HashMap&lt;&gt;();</span>
	private void initializeInternalUsers() {
<span class="fc" id="L134">		IntStream.range(0, InternalTestHelper.getInternalUserNumber()).forEach(i -&gt; {</span>
<span class="fc" id="L135">			String userName = &quot;internalUser&quot; + i;</span>
<span class="fc" id="L136">			String phone = &quot;000&quot;;</span>
<span class="fc" id="L137">			String email = userName + &quot;@tourGuide.com&quot;;</span>
<span class="fc" id="L138">			User user = new User(UUID.randomUUID(), userName, phone, email);</span>
<span class="fc" id="L139">			generateUserLocationHistory(user);</span>

<span class="fc" id="L141">			internalUserMap.put(userName, user);</span>
<span class="fc" id="L142">		});</span>
<span class="fc" id="L143">		logger.debug(&quot;Created &quot; + InternalTestHelper.getInternalUserNumber() + &quot; internal test users.&quot;);</span>
<span class="fc" id="L144">	}</span>

	private void generateUserLocationHistory(User user) {
<span class="fc" id="L147">		IntStream.range(0, 3).forEach(i-&gt; {</span>
<span class="fc" id="L148">			user.addToVisitedLocations(new VisitedLocation(user.getUserId(), new Location(generateRandomLatitude(), generateRandomLongitude()), getRandomTime()));</span>
<span class="fc" id="L149">		});</span>
<span class="fc" id="L150">	}</span>

	private double generateRandomLongitude() {
<span class="fc" id="L153">		double leftLimit = -180;</span>
<span class="fc" id="L154">		double rightLimit = 180;</span>
<span class="fc" id="L155">		return leftLimit + new Random().nextDouble() * (rightLimit - leftLimit);</span>
	}

	private double generateRandomLatitude() {
<span class="fc" id="L159">		double leftLimit = -85.05112878;</span>
<span class="fc" id="L160">		double rightLimit = 85.05112878;</span>
<span class="fc" id="L161">		return leftLimit + new Random().nextDouble() * (rightLimit - leftLimit);</span>
	}

	private Date getRandomTime() {
<span class="fc" id="L165">		LocalDateTime localDateTime = LocalDateTime.now().minusDays(new Random().nextInt(30));</span>
<span class="fc" id="L166">		return Date.from(localDateTime.toInstant(ZoneOffset.UTC));</span>
	}







}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>